// RoboBloX.js

(function(ext) {
    var device = null;
    var _rxBuf = [];

    // parameters are passed to this function as they appear
	// %n are passed as the strings shown (not the numeric value assigned)
	// the following arrays are used to convert the strings to matching numbers
	
	var action = {
		GET:1,
		RUN:2,
		RESET:4,
		START:5
	};

	var devices = {
		VERSION : 0,
		ULTRASONIC_SENSOR : 1,
		TEMPERATURE_SENSOR : 2,
		LIGHT_SENSOR : 3,
		POTENTIONMETER : 4,
		JOYSTICK : 5,
		GYRO : 6,
		SOUND_SENSOR : 7,
		RGBLED : 8,
		SEVSEG : 9,
		MOTOR : 10,
		SERVO : 11,
		ENCODER : 12,
		IR : 13,
		IRREMOTE : 14,
		PIRMOTION : 15,
		INFRARED : 16,
		LINEFOLLOWER : 17,
		IRREMOTECODE : 18,
		//19
		SHUTTER : 20,
		LIMITSWITCH : 21,
		BUTTON : 22,
		HUMITURE : 23,
		FLAMESENSOR : 24,
		GASSENSOR : 25,
		COMPASS : 26,
		STEPPER : 40,
		TOUCH_SENSOR : 51,


		//Basic Arduino
		//----------------
		DIGITAL : 30,        
		ANALOG : 31,         
		PULSEIN : 37,              
		PWM : 32,            
		TONE : 34,           
		SERVO_PIN : 33,      
		//serial write
		//serial avaliable
		//serial read
		ULTRASONIC : 36,
		TIMER : 50,
		//reset timer


		//RoboBloX
		//----------------        
		BLINKBLOX : 100,
		RAINBOWBLOX : 101,
		BUTTONBLOX : 110,
		LINEBLOX : 120,
		TRAFFICBLOX : 130,
		BATBLOX : 131,
		BEEPBLOX : 140,
		GOBLOX : 150,
		FACEBLOX : 160            //LEDMATRIX
	};
	

	var pins = {
		"D0":0,"D1":1,
		"D2":2,"D3":3,"D4":4,"D5":5,"D6":6,"D7":7,"D8":8,"D9":9,"D10":10,"D11":11,"D12":12,"D13":13,
		"A0":0,"A1":1,"A2":2,"A3":3,"A4":4,"A5":5,"A6":6,"A7":7
	};
	var levels = {
		HIGH:1,
		LOW:0,
		ON:1,
		OFF:0,
		On:1,
		Off:0,
		YES:1,
		NO:0,
		Yes:1,
		No:0
	};
	var axis = {
		'X-Axis':1,
		'Y-Axis':2,
		'Z-Axis':3
	}
	var colors ={
		"BLACK":0,"BROWN":1,"RED":2,"ORANGE":3,"YELLOW":4,"GREEN":5,"BLUE":6,"PURPLE":7,"GREY":8,"WHITE":9,
		"BK":0,"BN":1,"RD":2,"OG":3,"YW":4,"GN":5,"BU":6,"PR":7,"GY":8,"WT":9,
		"OFF_":0, "NEXT":-1
	};
	var directions ={
		"↑":100,"↓":-100,"╳":0,
		"↑ FORWARD":1,"↓ BACKWARD":2,"◄┐ TURN LEFT":3,"┌► TURN RIGHT":4,"↓○↑ SPIN LEFT (CCW)":5,"↑○↓ SPIN RIGHT (CW)":6,"◄┘ BACK LEFT":7,"└► BACK RIGHT":8,"╳ STOP":0
	};
	var tones ={"B0":31,
			"C1":33,"D1":37,"E1":41,"F1":44,"G1":49,"A1":55,"B1":62,
			"C2":65,"D2":73,"E2":82,"F2":87,"G2":98,"A2":110,"B2":123,
			"C3":131,"D3":147,"E3":165,"F3":175,"G3":196,"A3":220,"B3":247,
			"C4":262,"D4":294,"E4":330,"F4":349,"G4":392,"A4":440,"B4":494,
			"C5":523,"D5":587,"E5":659,"F5":698,"G5":784,"A5":880,"B5":988,
			"C6":1047,"D6":1175,"E6":1319,"F6":1397,"G6":1568,"A6":1760,"B6":1976,
			"C7":2093,"D7":2349,"E7":2637,"F7":2794,"G7":3136,"A7":3520,"B7":3951,
			"C8":4186,"D8":4699,
			"~B0":31,"~C1":33,"~C#1":35,"~D1":37,"~D#1":39,"~E1":41,"~F1":44,"~F#1":46,"~G1":49,"~G#1":52,"~A1":55,"~A#1":58,"~B1":62,
			"~C2":65,"~C#2":69,"~D2":73,"~D#2":78,"~E2":82,"~F2":87,"~F#2":93,"~G2":98,"~G#2":104,"~A2":110,"~A#2":117,"~B2":123,
			"~C3":131,"~C#3":139,"~D3":147,"~D#3":156,"~E3":165,"~F3":175,"~F#3":185,"~G3":196,"~G#3":208,"~A3":220,"~A#3":233,"~B3":247,
			"~C4":262,"~C#4":277,"~D4":294,"~D#4":311,"~E4":330,"~F4":349,"~F#4":370,"~G4":392,"~G#4":415,"~A4":440,"~A#4":466,"~B4":494,
			"~C5":523,"~C#5":554,"~D5":587,"~D#5":622,"~E5":659,"~F5":698,"~F#5":740,"~G5":784,"~G#5":831,"~A5":880,"~A#5":932,"~B5":988,
			"~C6":1047,"~C#6":1109,"~D6":1175,"~D#6":1245,"~E6":1319,"~F6":1397,"~F#6":1480,"~G6":1568,"~G#6":1661,"~A6":1760,"~A#6":1865,"~B6":1976,
			"~C7":2093,"~C#7":2217,"~D7":2349,"~D#7":2489,"~E7":2637,"~F7":2794,"~F#7":2960,"~G7":3136,"~G#7":3322,"~A7":3520,"~A#7":3729,"~B7":3951,
			"~C8":4186,"~C#8":4435,"~D8":4699,"~D#8":4978,
			"Middle C":262,"~C4~":262};
	var beats = {"Half":500,"Quarter":250,"Eighth":125,"Whole":1000,"Double":2000,"Zero":0,
				"1/16":63,"1/8":125,"1/4":250,"1/2":500,"Whole":1000,"Double":2000,
				"1/8 ♪":125,"1/4 ♩ᅟ":250,"1/2 d":500,"Whole o":1000};
	var values = {};
	var indexs = [];
	
	var startTimer = 0;
	var versionIndex = 0xFA;
    ext.resetAll = function(){
    	device.send([0xff, 0x55, 2, 0, 4]);
    };
	
	function toPairedValue(val, pairs) {
		return ( typeof val=="string" ? pairs[val] : new Number(val) );
	};
	
	ext.runRoboBloX = function(){
		responseValue();
	};
	
	//================ROBOBLOX=============================
	ext.blinkblox = function(pin,level) {
        runPackage(devices.BLINKBLOX,toPairedValue(pin,pins),toPairedValue(level,levels));
	}
	
	ext.buttonblox = function(nextID,pin){
		getPackage(nextID,devices.BUTTONBLOX,toPairedValue(pin,pins));
	};
	
	ext.lineblox = function(nextID,pin) {
		getPackage(nextID,devices.LINEBLOX,toPairedValue(pin,pins));
	};
	
	ext.batblox = function(nextID,trig,echo) {
		getPackage(nextID,devices.BATBLOX,toPairedValue(trig,pins),toPairedValue(echo,pins));
	};
		
	ext.trafficblox = function(color, pinRd, pinYw, pinGn) {
		runPackage(devices.TRAFFICBLOX,1,toPairedValue(color,colors),toPairedValue(pinRd,pins), toPairedValue(pinYw,pins), toPairedValue(pinGn,pins));
	};
	
	ext.beepbloxTone = function(pin,note,duration) {
		runPackage(devices.BEEPBLOX, toPairedValue(pin,pins), 1, short2array(toPairedValue(note,tones)), short2array(toPairedValue(duration,beats)));
	};

	ext.beepbloxWav = function(filename,wait) {
		runPackage(devices.BEEPBLOX, 9, 2, toPairedValue(wait, levels), filename.length, string2array(filename));
	};
	
	ext.gobloxDrive = function(dir,speed) {
		runPackage(devices.GOBLOX,1,toPairedValue(dir,directions),speed);
	};
	
	ext.gobloxDriveDual = function(left,right) {
		runPackage(devices.GOBLOX, 2, toPairedValue(left,directions), toPairedValue(right,directions));
	};

	ext.facebloxReset = function(){
		runPackage(devices.FACEBLOX,1,0);
	};
	
	// ext.facebloxPicture  must be named showDraw to work with the mBlock drawing pop-up hack
	ext.showDraw_2 = function(blank1,blank2,blank3,bytes){
		runPackage(devices.FACEBLOX,1,2,0,0,bytes);
	};

	ext.facebloxMessage = function(message,scrollSpeed,charSpacing){
		message = message.toString();
		runPackage(devices.FACEBLOX,1,1,scrollSpeed,charSpacing,message.length,string2array(message));
	};
	
	ext.map = function(nextID, x, in_min, in_max, out_min, out_max) {
		var x2 = (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
		responseValue(nextID, Math.round(x2) );		
	};
	
	ext.seedrnd = function(pin) {
		// Not needed in Live mode
	};
	
	//=============================================================================
	
	/*
	ext.runDigital = function(pin,level) {
        runPackage(30,pin,typeof level=="string"?levels[level]:new Number(level));
    };
    ext.runPwm = function(pin,pwm) {
        runPackage(32,pin,pwm);
    };
	ext.runTone = function(pin,tone,beat){
		runPackage(34,pin,short2array(typeof tone=="number"?tone:tones[tone]),short2array(typeof beat=="number"?beat:beats[beat]));
	};
	ext.runServoRoboBloX = function(pin, angle){
		runPackage(33,pin,angle);
	};
	ext.resetTimer = function(){
		startTimer = new Date().getTime();
		responseValue();
	};
	ext.getDigital = function(nextID,pin){
		var deviceId = 30;
		getPackage(nextID,deviceId,pin);
	};
	ext.getAnalog = function(nextID,pin) {
		var deviceId = 31;
		getPackage(nextID,deviceId,pin);
    };
	ext.getPulse = function(nextID,pin,timeout) {
		var deviceId = 37;
		getPackage(nextID,deviceId,pin,short2array(timeout));
    };
	ext.getUltrasonicRoboBloX = function(nextID,trig,echo){
		var deviceId = 36;
		getPackage(nextID,deviceId,trig,echo);
	}
	ext.getTimer = function(nextID){
		if(startTimer==0){
			startTimer = new Date().getTime();
		}
		responseValue(nextID,new Date().getTime()-startTimer);
	}
	*/
		// ext.rb_showNumber = function(port,message){
		// if(typeof port=="string"){
			// port = ports[port];
		// }
		// runPackage(41,port,4,float2array(message));
	// };
	// ext.rb_showTime = function(port,hour,point,min){
		// if(typeof port=="string"){
			// port = ports[port];
		// }
		// runPackage(41,port,3,point==":"?1:0,hour,min);
	// }
	

/*
ff 55 len idx action device pin  slot  data a
0  1  2   3   4      5      6     7     8
*/
	
	function sendPackage(argList, action){
		var bytes = [0xff, 0x55, 0, 0, action];
		for(var i=0;i<argList.length;++i){
			var val = argList[i];
			if(val.constructor == "[class Array]"){
				bytes = bytes.concat(val);
			}else{
				bytes.push(val);
			}
		}
		bytes[2] = bytes.length - 3;		//length
		device.send(bytes);
	}
	
	function runPackage(){
		sendPackage(arguments, action.RUN);
	}
	
	function getPackage(){
		var nextID = arguments[0];
		Array.prototype.shift.call(arguments);
		sendPackage(arguments, action.GET);
	}

    var inputArray = [];
	var _isParseStart = false;
	var _isParseStartIndex = 0;
    function processData(bytes) {
		var len = bytes.length;
		if(_rxBuf.length>30){
			_rxBuf = [];
		}
		for(var index=0;index<bytes.length;index++){
			var c = bytes[index];
			_rxBuf.push(c);
			if(_rxBuf.length>=2){
				if(_rxBuf[_rxBuf.length-1]==0x55 && _rxBuf[_rxBuf.length-2]==0xff){
					_isParseStart = true;
					_isParseStartIndex = _rxBuf.length-2;
				}
				if(_rxBuf[_rxBuf.length-1]==0xa && _rxBuf[_rxBuf.length-2]==0xd&&_isParseStart){
					_isParseStart = false;
					
					var position = _isParseStartIndex+2;
					var extId = _rxBuf[position];
					position++;
					var type = _rxBuf[position];
					position++;
					//1 byte 2 float 3 short 4 len+string 5 double
					var value;
					switch(type){
						case 1:{
							value = _rxBuf[position];
							position++;
						}
							break;
						case 2:{
							value = readFloat(_rxBuf,position);
							position+=4;
							if(value<-255||value>1023){
								value = 0;
							}
						}
							break;
						case 3:{
							value = readInt(_rxBuf,position,2);
							position+=2;
						}
							break;
						case 4:{
							var l = _rxBuf[position];
							position++;
							value = readString(_rxBuf,position,l);
						}
							break;
						case 5:{
							value = readDouble(_rxBuf,position);
							position+=4;
						}
							break;
						case 6:
							value = readInt(_rxBuf,position,4);
							position+=4;
							break;
					}
					if(type<=6){
						responseValue(extId,value);
					}else{
						responseValue();
					}
					_rxBuf = [];
				}
			} 
		}
    }
	function readFloat(arr,position){
		var f= [arr[position],arr[position+1],arr[position+2],arr[position+3]];
		return parseFloat(f);
	}
	function readInt(arr,position,count){
		var result = 0;
		for(var i=0; i<count; ++i){
			result |= arr[position+i] << (i << 3);
		}
		return result;
	}
	function readDouble(arr,position){
		return readFloat(arr,position);
	}
	function readString(arr,position,len){
		var value = "";
		for(var ii=0;ii<len;ii++){
			value += String.fromCharCode(_rxBuf[ii+position]);
		}
		return value;
	}
    function appendBuffer( buffer1, buffer2 ) {
        return buffer1.concat( buffer2 );
    }

    // Extension API interactions
    var potentialDevices = [];
    ext._deviceConnected = function(dev) {
        potentialDevices.push(dev);

        if (!device) {
            tryNextDevice();
        }
    }

    function tryNextDevice() {
        // If potentialDevices is empty, device will be undefined.
        // That will get us back here next time a device is connected.
        device = potentialDevices.shift();
        if (device) {
            device.open({ stopBits: 0, bitRate: 115200, ctsFlowControl: 0 }, deviceOpened);
        }
    }

    var watchdog = null;
    function deviceOpened(dev) {
        if (!dev) {
            // Opening the port failed.
            tryNextDevice();
            return;
        }
        device.set_receive_handler('RoboBloX',processData);
    };

    ext._deviceRemoved = function(dev) {
        if(device != dev) return;
        device = null;
    };

    ext._shutdown = function() {
        if(device) device.close();
        device = null;
    };

    ext._getStatus = function() {
        if(!device) return {status: 1, msg: 'RoboBloX disconnected'};
        if(watchdog) return {status: 1, msg: 'Probing for RoboBloX'};
        return {status: 2, msg: 'RoboBloX connected'};
    }

    var descriptor = {};
	ScratchExtensions.register('RoboBloX', descriptor, ext, {type: 'serial'});
})({});
