#ifndef firmware_roboblox_h
#define firmware_roboblox_h

/*************************************************************************
* File Name          : roboblox_firmware.ino
* Author             : Ander, Mark Yan
* Updated            : Dash, Mike
* Version            : V2.1
* Date               : 2017-11-20
* Description        : Firmware modified from orion firmware V0a.01.105  
* License            : CC-BY-SA 3.0
**************************************************************************/
#include <Arduino.h>
//#include <Servo.h> 
#include "roboblox.h"
#include "faceblox.h"
#include "beepblox.h"


namespace Firmware
{
//============================DEVICE CODES==============================
enum device {
VERSION = 0,
ULTRASONIC_SENSOR = 1,
TEMPERATURE_SENSOR = 2,
LIGHT_SENSOR = 3,
POTENTIONMETER = 4,
JOYSTICK = 5,
GYRO = 6,
SOUND_SENSOR = 7,
RGBLED = 8,
SEVSEG = 9,
MOTOR = 10,
SERVO_OTHER = 11,
ENCODER = 12,
IR = 13,
IRREMOTE = 14,
PIRMOTION = 15,
INFRARED = 16,
LINEFOLLOWER = 17,
IRREMOTECODE = 18,
//19
SHUTTER = 20,
LIMITSWITCH = 21,
BUTTON = 22,
HUMITURE = 23,
FLAMESENSOR = 24,
GASSENSOR = 25,
COMPASS = 26,
STEPPER = 40,
TOUCH_SENSOR = 51,


//Basic Arduino
//----------------
DIGITAL = 30,        
ANALOG = 31,         
PULSEIN = 37,              
PWM = 32,            
TONE = 34,           
SERVO = 33,      
//serial write
//serial avaliable
//serial read
ULTRASONIC = 36,
TIMER = 50,
//reset timer


//RoboBloX
//----------------        
BLINKBLOX = 100,
RAINBOWBLOX = 101,
BUTTONBLOX = 110,
LINEBLOX = 120,
TRAFFICBLOX = 130,
BATBLOX = 131,
BEEPBLOX = 140,
GOBLOX = 150,
FACEBLOX = 160            //LEDMATRIX
};

enum action {
GET=1,
RUN=2,
RESET=4,
START=5
};

void RoboBloX_mBlock_Live();
unsigned char readBuffer(int index);
void writeBuffer(int index,unsigned char c);
void writeHead();
void writeEnd();
void writeSerial(unsigned char c);
void readSerial();
/*
ff 55 len idx action device port  slot  data a
0  1  2   3   4      5      6     7     8
*/
void parseData();
void callOK();
void sendByte(char c);
void sendString(String s);
void sendFloat(float value);
void sendShort(double value);
void sendDouble(double value);
short readShort(int idx);
float readFloat(int idx);
long readLong(int idx);
char* readString(int idx,int len);
uint8_t* readUint8(int idx,int len);
void runModule(int device);
void readSensor(int device);
}


#endif
