#ifndef roboblox_h
#define roboblox_h

#include <Arduino.h>

enum Color {NEXT=-1,BLACK,BROWN,RED,ORANGE,YELLOW,GREEN,BLUE,PURPLE,GREY,WHITE};
enum ColorAbv { BK,BN,RD,OG,YW,GN,BU,PR,GY,WT};

namespace RoboBloX
{
	void BlinkBloX(int pin, int data);
	int LineBloX(int pin);
	void TrafficBloX(Color color, int pinRd, int pinYw, int pinGn);
	void TrafficBloX(char color, int pinRd, int pinYw, int pinGn);
	void TrafficBloX(char *null1, Color color, char *null2, int pinRd, int pinYw, int pinGn);
  float BatBloX(int trig,int echo);
  void BeepBloX(int pin, String melody, int tempo);
}


class GoBloX 
{
	enum Direction {STOP,FORWARD,BACKWARD,TURN_LEFT,TURN_RIGHT,SPIN_LEFT,SPIN_RIGHT,BACK_LEFT,BACK_RIGHT};
	public:
	GoBloX(int pinLeftA=4, int pinLeftB=5, int pinRightA=6, int pinRightB=7);
	void driveDual(double left, double right);
	void drive(Direction dir, int speed);
	void drive(char dir, int speed);	//^,V,<,>,(,),J,L,X
	void drive(int dir, int speed);
	private:
	const int _pinLeftA, _pinLeftB, _pinRightA, _pinRightB;
	uint8_t speedLeft, speedRight, pwmLeft, pwmRight;
};



#endif
